const app = getApp();
const httpGet = function(url, callback) {
  http(url, callback);
}
const httpPost = function(url, data, callback) {
  http(url, callback, "POST", JSON.stringify(data));
}
const httpPut = function(url, data, callback) {
  http(url, callback, "PUT", JSON.stringify(data));
}
const httpDelete = function(url, callback) {
  http(url, callback, "DELETE");
}

const http = function(url, callback, method, data) {
  wx.request({
    url: app.globalData.host + '/api' + url,
    method: !method ? "GET" : method,
    dataType: "json",
    data: !data ? null : data,
    header: {
      'content-type': 'application/json',
      'Cookie': 'XSRF-TOKEN=' + wx.getStorageSync('XSRFToken'),
      "X-XSRF-TOKEN": wx.getStorageSync('XSRFToken'),
      "Authorization": wx.getStorageSync('token')
    },
    success: function(response) {
      let result = response.data;
      console.log('result');
      console.log(result);
      console.log(response);
      console.log(response.statusCode);

      if (response.statusCode == 401) {
        wx.showToast({
          title: '登录已过期',
          icon: 'success',
          image: '/images/error.png',
          duration: 2000
        })
        wx.navigateTo({
          url: '../../pages/welcome/index'
        })
      } else if (response.statusCode == 403){
        console.log(result);
        wx.showToast({
          title: '权限受限',
          icon: 'success',
          image: '/images/error.png',
          duration: 2000
        })
      }
      console.log(result.messageType);
      if (result.messageType == 'success') {
        callback(result);
      } else {
      }
    },
    fail: function(res) {
      wx.showToast({
        title: '请求超时',
        icon: 'success',
        image: '/images/error.png',
        duration: 10000
      })

    }
  })
}
const formatTime = date => {
  const year = date.getFullYear();
  const month = date.getMonth() + 1;
  const day = date.getDate();
  const hour = date.getHours();
  const minute = date.getMinutes();
  const second = date.getSeconds();
  return [year,month,day].map(formatNumber).join('-') + ' ' + [hour,minute,second].map(formatNumber).join(':');
}
const formatDate = (date,days) =>{
  const year = date.getFullYear();
  const month = date.getMonth() + 1;
  const day = date.getDate()+days;
  return [year,month,day].map(formatNumber).join('-');
}
const formatNumber = n =>{
  n = n.toString();
  return n[1] ? n: '0' + n;
}

module.exports = {
  httpGet: httpGet,
  httpPost: httpPost,
  httpPut: httpPut,
  httpDelete: httpDelete,
  http: http,
  formatTime: formatTime,
  formatDate: formatDate
}
